<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendasComparativoService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function findReport($conditions){
        try{
            $params = array(
                ":CDFILIAL" => implode('_', $conditions['CDFILIAL']),
                ":NRORG"    => $conditions['NRORG'],
                ":MESANO"   => $conditions['NMMES1'],
                ":MESANO2"  => $conditions['NMMES2'],
                ":MESANO3"  => $conditions['NMMES3']
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_VENDAS_COMPARATIVO, $params);
        } catch(Exception $e){
            throw $e;
        }
        
    }
    
    const GET_VENDAS_COMPARATIVO = "
        SELECT TOTAL.CDLOJA, TOTAL.NMLOJA, TOTAL.CDFILIAL, TOTAL.NMFILIAL AS LABELFILIAL, TOTAL.NRORG, 
               TOTAL.MESANO AS MESANO, NVL(SUM(TOTAL.TOT), 0) AS TOT,
               CASE WHEN NVL(SUM(TOTAL.TOT), 0) = 0 THEN 0 ELSE 100 END AS PERCEN1,
               TOTAL.MESANO2 AS MESANO2, NVL(SUM(TOTAL.TOT2), 0) TOT2, NVL(ROUND((((NVL(SUM(TOTAL.TOT), 0) - NVL(SUM(TOTAL.TOT2), 0))/ NVL(SUM(TOTAL.TOT), 1))*-100),2 ), 0) AS PERCEN2,               
               TOTAL.MESANO3 AS MESANO3, NVL(SUM(TOTAL.TOT3), 0) AS TOT3, NVL(ROUND((((NVL(SUM(TOTAL.TOT2), 0) - NVL(SUM(TOTAL.TOT3), 0))/ NVL(SUM(TOTAL.TOT2), 1))*-100),2), 0) AS PERCEN3
        FROM (SELECT FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, TO_CHAR(V.DTENTRVENDA, 'MM/YYYY') AS MESANO, SUM(V.VRTOTVENDA) AS TOT, :MESANO2 MESANO2, NULL AS TOT2, :MESANO3 MESANO3, NULL AS TOT3
          FROM VENDA V
          JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                 FROM LOJA L
                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG 
                         FROM FILIAL F
                        WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 
                          AND F.NRORG =:NRORG
                      ) FI
                   ON L.CDFILIAL = FI.CDFILIAL
                  AND L.NRORG = FI.NRORG
               ) FILO
            ON V.CDFILIAL = FILO.CDFILIAL
           AND V.CDLOJA = FILO.CDLOJA
           AND V.NRORG = FILO.NRORG
         WHERE TO_CHAR(V.DTENTRVENDA, 'MM/YYYY') = :MESANO
           AND V.IDSITUVENDA = 'O'
         GROUP BY FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, TO_CHAR(V.DTENTRVENDA, 'MM/YYYY')
        
        UNION ALL
        
        SELECT FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, :MESANO MESANO, NULL AS TOT, TO_CHAR(V.DTENTRVENDA, 'MM/YYYY') AS MESANO2, SUM(V.VRTOTVENDA) AS TOT2, :MESANO3 MESANO3, NULL AS TOT3
          FROM VENDA V
          JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                 FROM LOJA L
                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG 
                         FROM FILIAL F
                        WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 
                          AND F.NRORG =:NRORG
                      ) FI
                   ON L.CDFILIAL = FI.CDFILIAL
                  AND L.NRORG = FI.NRORG
               ) FILO
            ON V.CDFILIAL = FILO.CDFILIAL
           AND V.CDLOJA = FILO.CDLOJA
           AND V.NRORG = FILO.NRORG
         WHERE TO_CHAR(V.DTENTRVENDA, 'MM/YYYY') = :MESANO2
           AND V.IDSITUVENDA = 'O'
         GROUP BY FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, TO_CHAR(V.DTENTRVENDA, 'MM/YYYY')
         
        UNION ALL
        
        SELECT FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, :MESANO MESANO, NULL TOT, :MESANO2 MESANO2, NULL TOT2, TO_CHAR(V.DTENTRVENDA, 'MM/YYYY') AS MESANO3, SUM(V.VRTOTVENDA) AS TOT3
          FROM VENDA V
          JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                 FROM LOJA L
                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG 
                         FROM FILIAL F
                        WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 
                          AND F.NRORG =:NRORG
                      ) FI
                   ON L.CDFILIAL = FI.CDFILIAL
                  AND L.NRORG = FI.NRORG
               ) FILO
            ON V.CDFILIAL = FILO.CDFILIAL
           AND V.CDLOJA = FILO.CDLOJA
           AND V.NRORG = FILO.NRORG
         WHERE TO_CHAR(V.DTENTRVENDA, 'MM/YYYY') = :MESANO3
           AND V.IDSITUVENDA = 'O'
         GROUP BY FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, TO_CHAR(V.DTENTRVENDA, 'MM/YYYY')) TOTAL
         GROUP BY TOTAL.CDLOJA, TOTAL.NMLOJA, TOTAL.CDFILIAL, TOTAL.NMFILIAL, TOTAL.NRORG, TOTAL.MESANO, TOTAL.MESANO2, TOTAL.MESANO3
    ";
}